from bob import BobConn
import bob as BOB
import time
import util

def closetun(nick):
    bob = BOB.BobConn()
    try:
        bob.getnick(nick)
        bob.stop()
        while bob.show()['stopping'] == 'true':
            time.sleep(1)
        bob.clear()
    except Exception as E:
        if util.DEBUG == True:
            print repr(E)
    bob.quit()
    bob.close()
class Forward():
    def __init__(self,bob):
        self.bob = bob
        self.bob.quiet("true")
        self.bob.start()
        while bob.show()['starting'] == 'true':
            time.sleep(1)
        self.bob.quit()
        self.bob.close()
    def close(self):
        closetun(self.nick)
##to connect to a dest, open a socket to port, and send dest/b32 + "\n"
class CliForw(Forward):
    def __init__(self,port):
        self.port = port
        self.nick = 'C'+util.RandNick()
        bob = BobConn()
        bob.setnick(self.nick)
        bob.newkeys()
        bob.SetIN(BOB.BOB_IP,port)
        Forward.__init__(self,bob)
##creates an i2p tunnel that forwards connections to a local port
class ServForw(Forward):
    def __init__(self,port,private="",nick=""):
        bob = BobConn()
        if private == "":
            if nick == "":
                self.nick = 'L'+util.RandNick()
            else:
                self.nick = nick
            bob.setnick(self.nick)
            bob.newkeys()
        else:
            if nick == "":##will raise if tunnel exists under different nick
                self.nick = 'L'+util.RandNick()
                bob.setnick(self.nick)
                bob.setkeys(private)
            else:
                self.nick = nick
                try:
                    bob.getnick(self.nick)
                    bob.stop()
                    while bob.show()['stopping'] == 'true':
                        time.sleep(1)
                    bob.setkeys(private)
                except:
                    bob.setnick(self.nick)
                    bob.setkeys(private)
        bob.getdest()
        bob.getkeys()
        self.public = bob.public
        self.b32 = bob.b32
        self.private = bob.private
        bob.SetOUT(BOB.COMP_IP,port)
        Forward.__init__(self,bob)
